precision highp float;

uniform sampler2D texShadowMap;

varying vec4 v_v4ShadowMapPosition;
varying highp vec2 v_v2TexCoord;
varying highp vec2 v_v2TexCoordLightmap;

void main() 
{
	if (v_v4ShadowMapPosition.x > 1.0)
	{
		discard;
	}
	else if (v_v4ShadowMapPosition.x < 0.0)
	{
		discard;
	}
	else if (v_v4ShadowMapPosition.y > 1.0)
	{
		discard;
	}
	else if (v_v4ShadowMapPosition.y < 0.0)
	{
		discard;
	}
	else if (v_v4ShadowMapPosition.z < 0.0)
	{
		discard;
	}
	else if (v_v4ShadowMapPosition.z > 1.0)
	{
		discard;
	}
	
	float fBias = 0.005;
	
/*	vec2 poissonDisk[4] = vec2[](
	  vec2( -0.94201624, -0.39906216 ),
	  vec2( 0.94558609, -0.76890725 ),
	  vec2( -0.094184101, -0.92938870 ),
	  vec2( 0.34495938, 0.29387760 )
	);
	
	float fVisibility = 1.0;
	for (int i=0;i<4;i++)
	{
		if ( texture( texShadowMap, v_v4ShadowMapPosition.xy + poissonDisk[i]/1000.0 ).r  <  v_v4ShadowMapPosition.z - fBias )
		{
			fVisibility -= 0.25;
		}
	}*/


	float fVisibility = 1.0;
	if ( texture2D ( texShadowMap, v_v4ShadowMapPosition.xy + vec2( -0.94201624,  -0.39906216 )/1000.0 ).r  <  v_v4ShadowMapPosition.z - fBias ) fVisibility -= 0.25;
	if ( texture2D( texShadowMap, v_v4ShadowMapPosition.xy + vec2(  0.94558609,  -0.76890725 )/1000.0 ).r  <  v_v4ShadowMapPosition.z - fBias ) fVisibility -= 0.25;
	if ( texture2D( texShadowMap, v_v4ShadowMapPosition.xy + vec2( -0.094184101, -0.92938870 )/1000.0 ).r  <  v_v4ShadowMapPosition.z - fBias ) fVisibility -= 0.25;
	if ( texture2D( texShadowMap, v_v4ShadowMapPosition.xy + vec2(  0.34495938,   0.29387760 )/1000.0 ).r  <  v_v4ShadowMapPosition.z - fBias ) fVisibility -= 0.25;




	gl_FragColor = vec4(fVisibility, fVisibility, fVisibility, 0.1);	

/*	
	vec4 shadowData = texture2D(texShadowMap, v_v4ShadowMapPosition.xy);
	if (shadowData.r < v_v4ShadowMapPosition.z - fBias)
	{
		gl_FragColor = vec4(0.3, 0.3, 0.3, 0.5);	
//		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);	
	}
	else
	{
		gl_FragColor = vec4(1.0, 1.0, 1.0, 0.1);	
//		gl_FragColor = vec4(0.5, 0.0, 0.5, 1.0);
	}
*/
}
